%{!?_unitdir: %global _unitdir /lib/systemd/system}
%define user_group  ircd

Name:           ircd-hybrid
Version:        8.1.13
Release:        2%{?dist}
Summary:        A lightweight, high-performance internet relay chat daemon.

Group:          System Environment/Daemons
License:        GPLv2
URL:            http://www.ircd-hybrid.org/
Source0:        http://prdownloads.sourceforge.net/ircd-hybrid/%{name}-%{version}.tgz
Source1:        ircd.service
Source2:        ircd.sysconfig
Source3:        ircd.fedora.conf
Source4:        ircd.logrotate
Source5:        ircd.init

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  openssl-devel, bison, flex
BuildRequires:  GeoIP-devel

Conflicts:      ircd-ratbox

Requires(pre):       shadow-utils
%if 0%{?fedora} >= 17
Requires(post):      systemd-units
Requires(preun):     systemd-units
Requires(postun):    systemd-units
%else
Requires(post):      /sbin/chkconfig
Requires(preun):     /sbin/chkconfig
Requires(preun):     /sbin/service
Requires(postun):    /sbin/service
%endif

%description
A lightweight, high-performance internet relay chat daemon.

%package mkpasswd
Summary:    Password hash generator for ircd-hybrid
Group:      Applications/File
Conflicts:  ircd-ratbox-mkpasswd

%description mkpasswd
Ircd-mkpasswd is a password hash generator for ircd-hybrid.

%prep
%setup -q
mv -f tools/README tools/README.tools

%build
%configure \
	--sysconfdir=%{_sysconfdir}/ircd \
	--libdir=%{_datadir} \
	--enable-openssl \
	--enable-assert \
	--enable-kqueue \
	--enable-epoll \
	--enable-devpoll \
	--enable-poll \
	--enable-select \
	--enable-halfops

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'

mv -f $RPM_BUILD_ROOT%{_bindir}/mkpasswd $RPM_BUILD_ROOT%{_bindir}/ircd-mkpasswd
%if 0%{?fedora} >= 17
install -D -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_unitdir}/ircd.service
%else
install -D -m755 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/ircd
%endif
install -D -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/ircd
install -D -m644 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/ircd/ircd.conf
install -D -m664 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/ircd
install -D -m755 tools/mkkeypair $RPM_BUILD_ROOT%{_bindir}/mkkeypair

mkdir -p $RPM_BUILD_ROOT%{_var}/log/ircd  $RPM_BUILD_ROOT%{_var}/run/ircd-hybrid
mv -f $RPM_BUILD_ROOT%{_sysconfdir}/ircd/reference.conf $RPM_BUILD_ROOT%{_sysconfdir}/ircd/ircd.conf.dist
mv $RPM_BUILD_ROOT%{_datadir}/ircd-hybrid-old/* $RPM_BUILD_ROOT%{_datadir}/ircd-hybrid/

%pre
getent group ircd  >/dev/null || groupadd -r ircd
getent passwd ircd >/dev/null || \
useradd -r -g ircd -d %{_var}/run/ircd-ratbox -s /sbin/nologin \
    -c "ircd-ratbox user" ircd

%post
%if 0%{?fedora} >= 17
if [ $1 -eq 1 ] ; then
	# Initial installation
	/bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi
%else
/sbin/chkconfig --add icinga
%endif

%preun
%if 0%{?fedora} >= 17
if [ $1 -eq 0 ] ; then
	# Package removal, not upgrade
	/bin/systemctl --no-reload disable ircd.service > /dev/null 2>&1 || :
	/bin/systemctl stop ircd.service > /dev/null 2>&1 || :
fi
%else
	/sbin/service ircd stop &>/dev/null || :
	/sbin/chkconfig --del ircd
%endif

%postun
%if 0%{?fedora} >= 17
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
	# Package upgrade, not uninstall
	/bin/systemctl try-restart ircd.service >/dev/null 2>&1 || :
fi
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README doc/*.txt doc/technical doc/Tao-of-IRC.940110
%doc tools/README.respond tools/README.tools
%{_bindir}/mkkeypair
%{_bindir}/respond
%{_sbindir}/ircd
#{_datadir}/ircd-hybrid/modules/*.so
#{_datadir}/ircd-hybrid/modules/autoload/*.so
%{_datadir}/ircd-hybrid/*
%{_mandir}/man8/ircd.8*
%if 0%{?fedora} >= 17
%{_unitdir}/ircd.service
%else
%{_sysconfdir}/rc.d/init.d/ircd
%endif
%{_sysconfdir}/sysconfig/ircd
%config(noreplace) %{_sysconfdir}/ircd/ircd.conf
%config %{_sysconfdir}/ircd/ircd.conf.dist
%{_sysconfdir}/logrotate.d/ircd
%dir %attr(750,ircd,ircd) %{_var}/log/ircd
%dir %attr(750,ircd,ircd) %{_var}/run/ircd-hybrid

%files mkpasswd
%doc tools/README.mkpasswd
%{_bindir}/ircd-mkpasswd

%changelog
* Tue Feb 04 2014 momo-i <webmaster@momo-i.org> - 8.1.13-2
- Fixed ircd.conf
- move *.so /usr/lib{64} to /usr/share

* Tue Feb 04 2014 momo-i <webmaster@momo-i.org> - 8.1.13-1
- Initial rpm release
